﻿package
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.utils.Timer;
	import flash.events.TimerEvent;

	//hlavna trieda Pexeso
	public class Pexeso extends MovieClip
	{
		//pripravene premenne
		public var karty: Array = new Array(); //pole kariet
		public var otoceneKarty: Array = new Array();
		public var pocetKariet: int = 16; //celkovy pocet kariet v hre
		public var pocetKarietVriadku: int = 4;
		public var karta: symbolKarta; //obsahuje vytvoreny symbol hracich kariet
		public var nahodna: int, oznacena: int; //obsahuju cisla kariet pre miesanie
		public var mozeHrat: Boolean = true;
		public var oneskorenie: Timer, cashry: Timer;
		public var skore: int, minuta: int, sekunda: int;

		//konstruktor triedy Pexeso - hlavna funkcia
		public function Pexeso()
		{
			
		}		
		public function Hra()
		{
			cashry = new Timer(1000);
			cashry.start();
			cashry.addEventListener(TimerEvent.TIMER, plynutieCasu);
			//cyklus na vytvorenie kariet - umiestni dvojice cisel do pola karty
			for (var i: int = 0; i < pocetKariet; i++)
			{
				karty.push(Math.floor(i / 2));
			}
			//cyklus na pomiesanie kariet
			for (var k: int = pocetKariet - 1; k > 0; k--)
			{
				nahodna = Math.floor(Math.random() * k);
				oznacena = karty[k];
				karty[k] = karty[nahodna];
				karty[nahodna] = oznacena;
			}
			//cyklus na rozmiestnenie kariet na scenu
			for (var j: int = 0; j < pocetKariet; j++)
			{
				karta = new symbolKarta(); //vlozenie vytvorenej karty do premennej
				addChild(karta); //pridanie karty na scenu
				karta.typKarty = karty[j]; //vytvorenie vlastnosti typ karty - cislo obrazku na lici karty
				karta.gotoAndStop(9);
				karta.height = 440 / (pocetKariet / pocetKarietVriadku);
				karta.width = karta.height;
				karta.x = (karta.width + 5) * (j % pocetKarietVriadku) + karta.width / 2;
				karta.y = (karta.height + 5) * Math.floor(j / pocetKarietVriadku) + karta.height / 2;
				karta.buttonMode = true;
				karta.addEventListener(MouseEvent.CLICK, otocKartu);
			}

		}
		//funkcia otaca a kontroluje otocene karty
		private function otocKartu(udalost: MouseEvent)
		{
			if (mozeHrat == true) //nastavenie hodnoty pre premennu mozeHrat
			{
				var otocenaKarta: symbolKarta = udalost.currentTarget as symbolKarta;
				//kontrola ci je karta otocena
				if (otoceneKarty.indexOf(otocenaKarta) == -1)
				{
					otocenaKarta.gotoAndStop(otocenaKarta.typKarty + 1);
					otoceneKarty.push(otocenaKarta);
				}
				//kontrola ci su otocene dve karty
				if (otoceneKarty.length == 2)
				{
					mozeHrat = false;
					oneskorenie = new Timer(1000);
					oneskorenie.start();
					//ak su otocene karty rovnake
					if (otoceneKarty[0].typKarty == otoceneKarty[1].typKarty)
					{
						oneskorenie.addEventListener(TimerEvent.TIMER, vezmiKarty);
					}
					else
					{
						oneskorenie.addEventListener(TimerEvent.TIMER, vratKarty);
					}
				}
			}
		}
		//odstranuje rovnake karty zo sceny
		private function vezmiKarty(udalost: TimerEvent)
		{
			oneskorenie.stop();
			skore += 10;
			skoreTxt.text = String(skore);
			removeChild(otoceneKarty[0]);
			removeChild(otoceneKarty[1]);
			otoceneKarty = new Array();
			mozeHrat = true;
		}
		//otaca karty ktore sa nezhoduju na rubovu stranu
		private function vratKarty(udalost: TimerEvent)
		{
			oneskorenie.stop();
			if (skore > 0)
			{
				skore -= 5;
			}
			skoreTxt.text = String(skore);
			otoceneKarty[0].gotoAndStop(9);
			otoceneKarty[1].gotoAndStop(9);
			otoceneKarty = new Array();
			mozeHrat = true;
		}
		private function plynutieCasu(udalost: TimerEvent)
		{
			sekunda++;
			if (sekunda == 60)
			{
				sekunda = 0;
				minuta++;
			}
			zobrazenieCasu(sekunda, minuta);
		}
		private function zobrazenieCasu(sek:int, min:int)
		{
			var dvojciferneCislo:String="00";
			var dvojCifSek:String=dvojciferneCislo.substr(0, dvojciferneCislo.length-String(sek).length)+String(sek);
			var dvojCifMin:String=dvojciferneCislo.substr(0, dvojciferneCislo.length-String(min).length)+String(min);
			casTxt.text = dvojCifMin+":"+dvojCifSek;
		}
	}

}